/*
 * $Id: cia.h,v 1.2 1994/12/12 16:59:44 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 * CIA 6526 and VIA 6522 register number declarations.
 * Interrupt signals are defined in vmachine.h.
 *
 * Written by
 *
 *
 * $Log: cia.h,v $
 * Revision 1.2  1994/12/12  16:59:44  jopi
 * Defines for registers
 *
 * Revision 1.1  1994/08/10  17:46:41  jopi
 * Initial revision
 *
 *
 *
 */

#ifndef X64_CIA_H
#define X64_CIA_H


#ifdef VIA6522

/*
 * MOS 6522 registers
 */
#define P_PORT_B	0  /* Port B */
#define P_PORT_A	1  /* Port A */
#define P_DDIR_B	2  /* Data direction register for port B */
#define P_DDIR_A	3  /* Data direction register for port A */

#define P_TIMER_AL	4  /* Timer A latch low */
#define P_TIMER_AH	5  /* Timer A latch high */
#define P_TIMER_CAL	6  /* Timer A count low */
#define P_TIMER_CAH	7  /* Timer A count high */

#define P_TIMER_BL	8  /* Timer B latch low */
#define P_TIMER_BH	9  /* Timer B latch high */
#define P_SERIAL	10 /* Serial port shift register */
#define P_AUX		11 /* Auxiliary control register */
#define P_PERIPH	12 /* Peripheral control register */

#define P_INTFLAG	13 /* Interrupt flag register */
#define P_INTREG	14 /* Interrupt control register */
#define P_PORT_AOUT	15 /* Port A output register */
#else

/*
 * MOS 6526 registers
 */
#define P_PORT_A	0  /* Port A */
#define P_PORT_B	1  /* Port B */
#define P_DDIR_A	2  /* Data direction register for port A */
#define P_DDIR_B	3  /* Data direction register for port B */

#define P_TIMER_AL	4  /* Timer A low */
#define P_TIMER_AH	5  /* Timer A high */
#define P_TIMER_BL	6  /* Timer B low */
#define P_TIMER_BH	7  /* Timer B high */

#define P_TOD_TEN	8  /* Time Of Day clock 1/10 s */
#define P_TOD_SEC	9  /* Time Of Day clock sec */
#define P_TOD_MIN	10 /* Time Of Day clock min */
#define P_TOD_HR	11 /* Time Of Day clock hour */

#define P_SERIAL	12 /* Serial port shift register */
#define P_INTREG	13 /* Interrupt control register */
#define P_CONT_A	14 /* Control register A */
#define P_CONT_B	15 /* Control register B */
#endif

#endif  /* X64_CIA_H */
