/*
 * $Id: joystick.c,v 1.1 1995/04/01 07:50:52 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 * This file implements joystick for Linux.
 *
 *
 * Written by
 *   Ulmer Lionel     (ulmer@poly.polytechnique.fr)
 *
 *
 * $Log: joystick.c,v $
 * Revision 1.1  1995/04/01  07:50:52  jopi
 * Initial revision
 *
 *
 */


#include <linux/joystick.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "extern.h"

void joyini(void);
void joyclose(void);
void joystick(void);

int joyfd;


void joyini(void)
{
	 
	 /* open device file */
	 joyfd=open("/dev/js0",O_RDONLY);
	 if (joyfd < 0) {
			printf("Open error...\n");
			end64();
	 }
	 
	 printf(" Found one joystick...\n");
}

void joyclose(void)
{
	 close (joyfd);
}

void joystick(void)
{
	 int status;
	 struct JS_DATA_TYPE js;

	 status=read(joyfd,&js,JS_RETURN);
	 if (status != JS_RETURN) {
			printf("Read error...\n");
			end64();
	 }
	 
	 if ((js.y<300) && !(joy1 & 1))
	 {
			if (debugflg)
			  printf("Up\n");
			
			joy1 |= 1;
	 } else if ((js.y>1000) && !(joy1 & 2))
	 {
			if (debugflg)
			  printf("Down\n");
			
			joy1 |= 2;
	 } else if ((js.y>=300) && (js.y<=1000))
	 {
			if (joy1 & 1)
			{
				 if (debugflg)
				   printf("Up released\n");
				 
				 joy1 &= ~1;
			} else if (joy1 & 2)
			{
				 if (debugflg)
				 	printf("Down released\n");
				 
				 joy1 &= ~2;
			}
	 }
	 
	 if ((js.x<300) && !(joy1 & 4))
	 {
			if (debugflg)
			  printf("Left\n");
			
			joy1 |= 4;
	 } else if ((js.x>1100) & !(joy1 & 8))
	 {
			if (debugflg)
			  printf("Rigth\n");
			
			joy1 |= 8;
	 } else if ((js.x>=300) && (js.x<=1100))
	 {
			if (joy1 & 4)
			{
				 if (debugflg)
				 	 printf("Left released\n");
				 
				 joy1 &= ~4;
			} else if (joy1 & 8)
			{
				 if (debugflg)
				 	 printf("Rigth released\n");
				 
				 joy1 &= ~8;
			}
	 }
	 
	 if ((js.buttons & 1) && !(joy1 & 16))
	 {
			if (debugflg)
			  printf("Button pressed\n");
			
			joy1 |= 16;
	 } else if (!(js.buttons & 1) && (joy1 & 16))
	 {
			if (debugflg)
			  printf("Button released\n");
			
			joy1 &= ~16;
	 }
	 
}                      
