/*
 * $Id: mshell.h,v 1.2 1995/04/01 07:54:09 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 * Defaults for the Monitor shell.
 *
 *
 * Written by
 *   Jarkko Sonninen (sonninen@lut.fi)
 *   Jouko Valta     (jopi@zombie.oulu.fi)
 *
 *
 * $Log: mshell.h,v $
 * Revision 1.2  1995/04/01  07:54:09  jopi
 * X64 0.3 PL 0
 * Prototypes.
 *
 * Revision 1.1  1994/12/12  16:59:44  jopi
 * Initial revision
 *
 *
 *
 */

#ifndef X64_MSHELL_H
#define X64_MSHELL_H


#define T_QUOTED 1
#define T_NUMBER 2
#define T_OTHER  3


#ifndef MODE_MON
#define MODE_MON  (1 << 5)
#endif


struct ms_table {
    char   *command;
    int     min_args;
    int     max_args;
    int    (*funcp) (void);
    char   *help_line;
};


char   *read_line ( char *, int );
int     split_args ( char *, int mode, int, int, char **, int  *, int  * ) ;
int     eval_command ( char *, int , struct ms_table * );
int     sconv ( char *, int, int );


#endif  /* X64_MSHELL_H */
