/*
 * $Id: printer.h,v 1.1 1995/04/01 07:50:52 jopi Exp $
 *
 * This file is part of Commodore 64 emulator.
 * See README for copyright notice
 *
 * Restricted Epson compatible Serial printer emulator.
 * Only text mode is supported.
 *
 *
 * Written by
 *   Jouko Valta  (jopi@stekt.oulu.fi)
 *
 *
 * $Log: printer.h,v $
 * Revision 1.1  1995/04/01  07:50:52  jopi
 * Initial revision
 *
 *
 *
 */

#ifndef X64_PRINTER_H
#define X64_PRINTER_H


#define UPPERCASE	0x91 /* boundary is 0x80 */
#define LOWCASE		0x11

#define T_OLUPPC	0x80 /* one line */
#define T_OLLOWC	0x40 /* one line */
#define T_UPPC		0x20
#define T_LOWC		0x10

#define T_HEXDUMP	0x4
#define T_CLEAN		0x2
#define T_ESC		0x1

#define T_CASE		(T_OLUPPC | T_OLLOWC | T_UPPC | T_LOWC)


typedef struct {
    int type;

    FILE *FileDs;
    char  ActiveName[256];
    char *lpCommand;

    /* Printer */

    int   lang;
    int   colour;
    int   graphic;

    /* Text processing */

    BYTE  quote;	/* flag */
    int   mode;		/* uppercase */
    short skip;		/* counter */

    /* Page */

    int   mgn_top;
    int   mgn_bottom;
    int   mgn_left;
    int   mgn_right;
    int   row;
    int   column;
} PRINTER;


#endif  /* X64_PRINTER_H */

