.TH X64 N "1 April 1995" "X Version 11" "Emulators and Simulators"
.SH NAME
x64,x128,c1541 \- Commodore 64 Emulator And Program Development System for X display
.SH SYNOPSIS
.B x64
[-asm] [-test] [-hex] [-debug] [-verbose] [-notraps]
[-fn <font>] [-display <display>] [-name <value>] [+colors] [-colors]
[-start \fImemory_address\fP]
[-basic \fIfilename\fP] [-kernel \fIfilename\fP]
[-ram \fIfilename\fP] [-exrom \fIexromfile\fP] [-module \fIn\fP]
[-revision \fIrevision\fP] [-directory \fIpath\fP] [-load \fIfilename\fP]
[-reu \fIreufile\fP] [-floppy \fIdisk\fP] [-printCommand <value>]

.B c1541 \fIoption\fP \fIdiskname\fP [\fIparameters\fP]
.br
.B c1541 [\fIdiskname\fP ... ]

.SH DESCRIPTION
.B X64
is a powerful Commodore 64 emulator with
a Machine Language Monitor built-in.
For the best possible compatibility
.B X64
emulates the hardware so that the original basic and kernel
routines can be used. Exact 6510 emulation is provided, as long
as those weird 'write-invalid-address' tricks are not taken into
account. Also cartridge and peripreral support (consisting of printers
and disk drives) are included. Thus, 
.B X64
is capable to run most of the normal C64 programs which do not
require other peripherals nor high speed computing like sound
and rasterline effects.
.br
Also a printer emulation is provided, supporting nationalized character
sets of the C64 family, to help processing text files in C64 format.
In order to make the best use of the printer emulation you should make
sure it is configured to suit your purposes. Especially series 3 LaserJets
and matrix printers are prone to jam upon encountering 8 bit characters.
On the other hand, use of bare standard ASCII causes a wide variety of
characters to be lost.
.SH OPTIONS
.TP 8
.B \-asm
starts the Machine Language Monitor upon initialization.
.TP
.B \-debug
select debug mode.
.TP
.B \-directory \fIpath\fP 
set directory path for project directory.
.TP
.B \-exrom \fIexrom\fP
specify the file to be loaded to cartridge ROM slot with -m option.
As default the name is "exrom".
.TP
.B \-floppy \fIdisk\fP
attaches specified file containing floppy disk image.
.TP
.B \-hex
toggle default number base to 10 or 16. Default is hexadecimal.
This option causes both all addresses given on the command line
to be interpreted according to the selected number system, and also 
changes the operation of Machine Language Monitor and Debugger
accordingly.
.TP
.B \-load \fIc64_program_name\fP
load a program into ram. There has to be the start address
included in the beginning of the program.
Also \fIstart_address\fP for the emulator should be set to the system
warm start (break) vector with
\-start option when loading BASIC programs, so that Basic 'NEW' is not
performed automatically.
.TP
.B \-bload \fIc64_program_name\fP [\fIload_address\fP]
load a machine language program into ram. Again, there has to be the
start address included in the beginning of the program.
Via specifying the \fIload_address\fP, user can, however intruct the
program to be loaded different place than the \fIload_address\fP
assumes.
.TP
.B \-module \fIn\fP
select the memory area where the C64 \fIexrom\fP module is located:
.br
1 = 8000-9FFF
2 = A000-BFFF
3 = 8000-BFFF
.TP
.B \-notraps
Disables the Kernel traps used for Serial Bus emulation, and thus
the bus too.
.TP
.B \-revision \fIrevision\fP
If installed in compilation, changes loaded Kernal code so that you
can use whichever \fIrevision\fP you select.
.br
For  64, the alternatives are: 0, 3, 67 and 100.
.br
For 128: 1 = Swedish, 2 = German, 3 = American.
.TP
.B \-brevision \fIrevision\fP
If installed in compilation, changes loaded C128 Basic code so that you
can use whichever \fIrevision\fP ('85' or '86') you select.
.TP
.B \-reu \fIreufile\fP
If installed in compilation, activates the RAM Expansion Unit and
specifies the filename for RAM image of the REU.
Existing file is loaded to memory upon startup.
The default filename is "reu".
.TP
.B -start \fIstart_address\fP
address of the power-up initialization routine. The default
is RESET (FCE2).
With a BASIC program being loaded, better result may be achieved by
using the BASIC warm start vector (FE66) instead.
.TP
.B \-verbose
select verbose mode.
.SH DEFAULTS
.SS Environment Variables
.PP
To select the default X server to connect to
.br
.ne 8
.IP
setenv DISPLAY "`uname -n`:0"
.PP
If you have 8-bit ;) machine, add the following line to your .login:
.br
.ne 8
.IP
setenv LC_CTYPE iso_8859_1
.SS X Application Resources
Under construction.
.SH USAGE
.SS Keyboard Layout
.TP 8
The following keys have special meaning for \fIX64\fP:
.TP 16
.B "F1 F2 F3 F4 F5 F6 F7 F8"
The C64 function keys
.TP
.B  asciicircum or asciitilde
up arrow (on US and scandinavian keyboards respectively).
.TP
.BI underscore
right arrow
.TP
.BI bar
Pound Sign
.TP
.BI Backspace
Inst
.TP
.BI Linefeed
Shifted Return
.TP
.BI Control_L
Control
.TP
.BI Alt_L
CBM Key (Press down Left Shift and then Alt to change character set.)
.TP
.BI Escape
STOP
.TP
.BI Tab
Restore
.TP
.BI Shift_R
The Right Shift key can be used to achieve characters shifted on the actual
keyboard but unshifted on the C64 one.
.SS Joystick
Joystick is available on Linux only.
.SS Mouse
The left mouse button while focus is in Control Window 
may be used to toggle on and off \fIdebug mode\fP.
.PP
A press of the middle button halts the emulator and starts the \fIMonitor\fP.
.PP
The right mouse button will open and close a
.B Control
.B Window,
which contains useful gadgets as well as some debug information.
.SS Control Window
Whenever the XDebugger is enabled at compilation time, Control Window is
available with step-by-step execution and program trace ability.
Note that the old Control Window from version 0.2.2 differs from the new
0.3.0 window in several ways. Description below applies to the new one.

The left side of the Control Window displays the part of program the CPU
is executing. User can scroll the viewing area when execution is halted,
by using the slider or cursor keys within the subwindow.
.br
The upper right part of the Control Window displays the 6510 registers with
their current content.
.br
In the lower right corner are gadgets for controlling the emulator.
.TP 10
.BI Trace
causes
.B x64
to update assembly window each time a new intruction is to be run.
.TP
.BI Stop
enforces the C64 emulator to halt.
.TP
 Two additional functions are available while emulator is halted.
.TP
.BI Cont
resumes the emulator.
.TP
.BI Step
CPU performs the next consecutive machine language instruction.
.SS Tracing a Routine
.LP
In order to follow excution of a machine language routine step by step,
you need to freeze the emulator.
.br
First, open the
.B Control
.B Window
with the right mouse button and click
.B Stop.
Return the pointer to the CBM display window and press the middle
mouse button to enter
.B Monitor.
Now, set the 6502 registers with appropriater values and enter a jump
command. (Typing 'x' has the same effect, if PC was correctly set.)
.br
The Xdebugger can now be used to follow progress of your routine.
.SH MONITOR
The
.B Monitor
has a small shell with command line editor and history utility controlled via
the cursor keys.
.pp
The following monitor commands are implemented:
.PD 1
.TP 8
.B "# % & $"
Numeric base conversion prefixes
.br
Decimal, Binary, Octal, and Hex respectively.
.TP
.B ">" \fIaddr\fP "\fIbytes|'string'\fP"
Write data into memory.
.TP
.B ":" \fIaddr\fP "\fIbytes|'string'\fP"
Write image data (e.g. sprites) into memory.
The values are represented by sequense of '-' and '*' for '0' and '1'
respectively.
.TP
.B ";" [\fIregisters\fP]
Same as 'registers'
.TP
.B \? [\fItopic\fP]
Help
.TP
.B asm [\fIaddr\fP]
Enters to line interpreter. `x' returns to command mode.
.br
The following syntax is used on input:
.br
[\fIaddr\fP] \fImnemonic\fP [\fIoperand\fP]
.TP
.B attach [#\fIdevice\fP] [\fIimagename\fP]
Attach floppy disk image file \fIimagename\fP for use on \fIdevice\fP.
Without \fIimagename\fP only detaches the previous one.
Also  note that the '#' before \fIdevice\fP number is required.
.TP
.B break [\fIstart\fP] [\fIend\fP]
Set up breakpoints (region). New timer code only.
.TP
.B call [\fIaddr\fP]
Run code at address specified.
.TP
.B clear \fIstart\fP [\fIend\fP]
Clear breakpoints in specified region. New timer code only.
.TP
.B compare \fIstart\fP \fIend|+len\fP "\fItarget\fP"
.TP
.B disassemble [\fIaddr\fP] [\fIend|+len\fP]
.TP
.B dump [\fIfilename\fP]
Save ram image to a file.
.TP
.B fill \fIstart\fP \fIend|+len\fP "\fIbytes|'string'\fP"
.TP
.B help [\fItopic\fP]
Show description on specified monitor command or addressing modes
for 65xx mnemonic. Without any parameters, displays the list of
available commands.
.TP
.B hunt \fIstart\fP \fIend|+len\fP "\fIbytes|'string'\fP"
.TP
.B image [\fIaddr\fP] [\fIend|+len\fP]
Displays memory dump in bit format.
.TP
.B jump [\fIaddr\fP [\fIregisters\fP]]
Run code at address specified. If specified, CPU registers are set using
.BI registers
command described below.
.TP
.B load \fIfilename\fP [\fIaddr\fP]
Load program into memory emulating Kernal load routine.
.TP
.B memory [\fIaddr\fP] [\fIend|+len\fP]
Displays memory dump in hex format.
.TP
.B number \fIstart\fP \fIend|+len\fP \fIorig.st\fP [\fIorig.end\fP] [\fIdisp\fP]
Relinks code.
.TP
.B registers [\fIregisters\fP]
Show or change the 6510 registers (PC AC XR YR PF SP).
.TP
.B save \fIfilename\fP \fIaddr\fP \fIend|+len\fP
Saves memory area.
.TP
.B time [\fIaddr\fP]
Calls \fIaddr\fP and displays the amount of 6502 time used until
a \fIBRK\fP instruction is encountered. Without parameters the
previous time is displayed.
.TP
.B transfer \fIstart\fP \fIend|+len\fP \fIdest\fP
Moves a memory area.
.TP
.B undump \fI[filename]\fP
Loads ram image from a file.
.TP
.B x
Exits the Monitor. I.e. returns to emulator.
.TP
.B quit
Exits the \fIx64\fP
.br
.TP 8
Note: All commands may be abbreviated.

.SH DISK DRIVE
.B X64
offers you also disk drive emulator which can be compiled as a
separate program as well. The 1541 emulation uses now binary files of
length 170kb as 35-track floppy disks.
Currently only PRG and SEQ file types and the most important DOS commands,
including some block operations are supported.
.br
There are up to four disk drives provided: #8 trough #10 simulate the 1541,
while #11 reads directly from the filesystem. There is also the standalone
program,
.B c1541
for maintaining the disk images. It can be operated from command line or
interactively.
.br
.TP 8
.B c1541 -\fIcommand\fP \fIdiskname\fP \fIparameters\fP
.TP
.B c1541 [\fIdiskname ...\fP]
Enters interactive mode with maximum 2 disk images.
.br
Syntax:
.B \fIcommand\fP [\fIparameters\fP]
.LP
To create a X64 Disk Image, use the
.BI format
or
.BI create
command on
.B c1541
.SS C1541 Commands
.LP
Note that the \fIdiskname\fP is not given as command argument
in interactive mode.
.br
The following commands are supported on c1541:
.TP 8
.PD 0
.B f \fIdiskname\fP 'name,id'
.TP
.B f [\fIdiskname\fP] 'name,id'
Format \fIdiskname\fP. Creates the file if needed.
.PD 1
.TP
.B d \fIdiskname\fP files
Delete files on \fIdiskname\fP.
.TP
.B l \fIdiskname\fP [\fIpattern\fP]
List files on \fIdiskname\fP
.TP
.B v \fIdiskname\fP
Validate disk.
.TP
.B c \fIdiskname\fP \fIoldname\fP [\fIoldname2\fP ...] \fInewname\fP
Copy or concatenate files.
.TP
.B cr \fIdiskname\fP \fIdump\fP ['\fIdescription\fP']
Make disk \fIdiskname\fP out of raw blockdump (683 blocks with 256 bytes each).
.TP
.B tape \fItapeimage\fP [\fIfiles\fP]
Copy files from tape image.
.TP
.B r \fIdiskname\fP \fI1541name\fP [\fIfsname\fP]
Read \fI1541name\fP on image into file \fIfsname\fP.
.TP
.B w \fIdiskname\fP \fIfsname\fP [\fI1541name\fP]
Write file \fIfsname\fP onto image as \fI1541name\fP.
.TP
.B i \fIdiskname\fP ['\fIdescription\fP']
Show information on \fIdiskname\fP and 1541 version.
If \fIdescription\fP is given, write it into the image header.
.LP
There are few more commands not available in direct mode:
.TP 8
.B attach [\fIdrive\fP] \fIimagename\fP
Attaches floppy image for use on \fIdrive\fP.
.TP
.B block [\fIdrive\fP:] [\fItrack\fP [\fIsector\fP [\fIdisp\fP]]]
Display hex dump for one disk sector.
.TP
.B help
Display list of available commands.
.TP
.B unit [\fIdevice\fP]
Change default disk drive to \fIdevice\fP.
.TP
.B quit
Quits
.B c1541
.pp
.SS Examples
.PD 1
.BD 0
.TP 8
First\, a disk image has to be formatted in file\, say test.dsk:
.LP
.RS
.ft 4
c1541 -f test.dsk 'DISKI,ID'
.ft 1
.RE
.LP
to move programs to it one may type e.g.:
.LP
.RS
.ft 4
c1541 -w test.dsk pieces_of_light PIECESOFLIGHT
.ft 1
.RE
.LP
Finally\, start the emulator with option:
.LP
.RS
.ft 4
x64 -floppy test.dsk
.ft 1
.RE
.LP
or use the Monitor command
.LP
.RS
.ft 4
attach test.dsk
.ft 1
.RE
.LP
After that you can load programs in emulator with simple
.LP
.RS
.ft 4
LOAD "$",8
.br
LOAD "PIECESOFLIGHT",8
.br
.ft 1
etc.
.RE
.LP
Loading normal C64 program file:
.LP
.RS
.ft 4
x64 -load progname -start fe66
.ft 1
.RE
.SH FILES
.PD 1
The following are reserved filenames, normally located in the
\fIproject directory\fP:
.TP 16
.B basic
The BASIC ROM Image
.TP
.B kernel
The KERNEL ROM Image
.TP
.B chargen
The CHARACTER ROM Image. If this file is not found, the
emulator uses default character set instead.
.TP
.B ram
Completed execution RAM Image
.TP
.B exrom
Cartridge ROM Image
.TP
.B reu
RAM Expansion Image
.br
The REU size can be defined at compilation time to 128, 256 or 512 KB.
.TP
.B inst
Debug information about executed program.

.SH SEE ALSO
.LP
.BR sed (1),
.BR tr (1),
.BR vi (1),
.BR fvcbm (1),
.BR iso2asc (1),
.BR petcat (N),
.BR ASCII (7),
.BR xmodmap (1),
.BR xkeymaped (N),
.BR X (1),
.BR sysinfo (1),
.BR "\fIX Toolkit documentation\fP",
.BR "CBM's \fIProgrammers' Reference Guide\fP series"

.SH BUGS
.LP
Since this program is under development, bugs are included for free.
.br
Please send your patches, bug reports and bug fixes to jopi@stekt.oulu.fi.

.SH RESTRICTIONS
.LP
VIC20, C64 and C128 basic and kernel are still under copyright, and thus
not included in the emulator. You have to grab your own copy of them.
.br
Note: The ROMs are not interchangeable.

To prevent fatal shock hazard do not disassemble nor hexdump this program.
No user crackable routines inside.

.SH COPYRIGHT
Copyright (c) 1993,1994,1995  Jarkko Sonninen, Teemu Rantanen and Jouko Valta.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
.br

.SH AUTHORS
.SS The original X64 code by:
 Jarkko Sonninen   (sonninen@lut.fi)
 Jouko Valta       (jopi@stekt.oulu.fi)
 Teemu Rantanen    (tvr@cs.hut.fi)
.SS Development and bug fixes by:
 Vesa-Matti Puro   (vmp@lut.fi)
 Hannu Helminen    (dm@stekt.oulu.fi)
 Richard Hable     (Richard.Hable@jk.uni-linz.ac.at)
 Frank Prindle     (Frank.Prindle@lambada.oit.unc.edu)
 Peter Weighill    (stuce@csv.warwick.ac.uk)
 Marko Makela      (msmakela@nic.funet.fi)
 Dan Miner         (dminer@nyx.cs.du.edu)
 Germano Caronni   (caronni@tik.ethz.ch)
 Dominique Strigl  (strigl@sxb.bsf.alcatel.fr)
 Craig Jackson     (Craig.Jackson@lambada.oit.unc.edu)
 Ulmer Lionel      (ulmer@poly.polytechnique.fr)
 Lasse Jyrkinen    (Lasse.Jyrkinen@uz.kuleuven.ac.be)
